//-----------------------------------------------------------------------------
//  TimpyH_Common_Defs.h
//-----------------------------------------------------------------------------
//
//  Copyright 2006, 2007 Chiaki Nakajima
//  Original copyright 2006 Silicon Laboratories, Inc.
//
//  Release 1.1
//      EFirst release
//      EF34x_MSD_USB_Main.hėp`𕪗
//
//-----------------------------------------------------------------------------
// Header File Preprocessor Directive
//-----------------------------------------------------------------------------

#ifndef _COMMON_DEFS_H_
#define _COMMON_DEFS_H_

//-----------------------------------------------------------------------------
//  Common Definitions
//-----------------------------------------------------------------------------

#ifndef _BYTE_DEF_
#define _BYTE_DEF_
typedef unsigned char BYTE;                     // BYTE type definition
#endif /* _BYTE_DEF_ */

#ifndef _UINT_DEF_
#define _UINT_DEF_
typedef unsigned int UINT;                      // UINT type definition
#endif /* _UINT_DEF_ */

#ifndef _ULONG_DEF_
#define _ULONG_DEF_
typedef unsigned long ULONG;                    // ULONG type definition
#endif /* _ULONG_DEF_ */

#ifndef _WORD_DEF_
#define _WORD_DEF_
typedef union {                                 // WORD type definition, for SDCC Compiler
    UINT i; 
    BYTE c[2];
} WORD;

#define LSB 0                                   // All words sent to and received from the host are
#define MSB 1                                   // little endian, this is switched by software when neccessary.
#endif /* _WORD_DEF_ */

#ifndef _INT_BA_DEF_
#define _INT_BA_DEF_
typedef union {                                 // byte-addressable INT
    int i;
    BYTE b[2];
} INT_BA;
#endif /* _INT_BA_DEF */

#ifndef _UINT_BA_DEF_
#define _UINT_BA_DEF_
typedef union {                                 // byte-addressable unsigned int
    UINT i;
    BYTE b[2];
} UINT_BA;
#endif /* _UINT_BA_DEF_ */

#ifndef _LONG_BA_DEF_
#define _LONG_BA_DEF_
typedef union {                                 // byte-addressable LONG
    long l;
    BYTE b[4];
} LONG_BA;
#endif /* _LONG_BA_DEF_ */

#ifndef _ULONG_BA_DEF_
#define _ULONG_BA_DEF_
typedef union {                                 // byte-addressable unsigned long
    ULONG l;
    BYTE b[4];
} ULONG_BA;
#endif /* _ULONG_BA_DEF */

// Constants
#define SYSCLK                  12000000        // SYSCLK frequency in Hz

// Port Assign
#define pSdCs                   P0_3
#define pUsbAccessLed           P3_4

// Function Macros
#define msb(x)                  (((x)>>8)&0x000000FFul)
#define lsb(x)                  ((x)&0x000000FFul)

#define Reset_MCU()             (RSTSRC |= 0x10)    // \tgEFAZbg

#endif /* _COMMON_DEFS_H_ */

/* End of TimpyH_Common_Defs.h */
