//-----------------------------------------------------------------------------
//  TimpyH_MSD_MSD.c
//-----------------------------------------------------------------------------
//
//  Copyright 2006, 2007 Chiaki Nakajima
//  Original copyright 2006 Silicon Laboratories, Inc.
//
//  Release 1.1
//      E\[X̐
//      EgpvZbTF340ɌC"__F340_VER__"`QƂ폜
//      Et@C"F34x_""TimpyH_"ɕύX
//
//  Release 1.0
//      ESiLabsUSB-MSD-RD(Release 1.1)ɁCTimpy Rev5.0pɑSʓIɕύX
//      ESDCCֈڐA
//      Esvȋ@\폜
//
//-----------------------------------------------------------------------------
//
//  Copyright 2006 Silicon Laboratories, Inc.
//  http://www.silabs.com
//
//  Release 1.1
//    -All changes by PKC
//    -09 JUN 2006
//    -No changes; incremented revision number to match project revision
//
//  Release 1.0
//    -Initial Release
//
//-----------------------------------------------------------------------------
//  Includes
//-----------------------------------------------------------------------------

#include "TimpyH_Common_Defs.h"
#include "TimpyH_MSD_USB_Main.h"
#include "TimpyH_MSD_Msd.h"
#include "TimpyH_MSD_Scsi.h"

#define DIRECTION_IN            0x80
#define DIRECTION_OUT           0x00

//#define CBW_SIGNATURE         0x55534243
#define CBW_SIGNATURE           0x43425355
//#define CSW_SIGNATURE         0x55534253
#define CSW_SIGNATURE           0x53425355

#define MSD_READY               0x00
#define MSD_COMMAND_TRANSPORT   0x01
#define MSD_DATA_IN             0x02
#define MSD_DATA_OUT            0x03
#define MSD_STATUS_TRANSPORT    0x04
#define MSD_DATA                0x05
#define MSD_DO_RESET            0xFF

BYTE __xdata Msd_State = MSD_READY;

CBW __xdata cbw;
CSW __xdata csw;

//----------------------------------------------------------------------------
//  Msd_Step
//----------------------------------------------------------------------------
//
//  This is a crank function. It checks if something is received and calls the
//  responding functions (USB).
//
//  Parameters   :
//  Return Value :
//----------------------------------------------------------------------------

void Msd_Step(void)
{
    switch (Msd_State) {
        case MSD_READY:
            if (Out_Count) {
                                                        // Look for a "valid" and "meaningful" CBW, as defined in the spec:
                                                        // Check size
                if (Out_Count != sizeof(CBW)) {
                    Out2_Get_Data(Out_Packet);
                    Out2_Done();
                    return;
                }

                Out2_Get_Data((BYTE *) &cbw);
                Out2_Done();
                                                        // Check signature, reserved bits & LUN
                if ((cbw.dCBWSignature != CBW_SIGNATURE)
                 || ((cbw.bmCBWFlags != DIRECTION_IN && cbw.bmCBWFlags != DIRECTION_OUT) 
                 || (cbw.bCBWLUN & 0xF0) || (cbw.bCBWCBLength > 16)) || (cbw.bCBWLUN != 0x00)) {
                    return;
                }
                Msd_State = MSD_DATA;
            }
            break;

        case MSD_DATA:
            Scsi_Rx();
            Msd_State = MSD_STATUS_TRANSPORT;
            break;

        case MSD_STATUS_TRANSPORT:
                                                        // Reply with a CSW:
            csw.dCSWSignature = CSW_SIGNATURE;
            csw.dCSWTag = cbw.dCBWTag;
            csw.bCSWStatus = Scsi_Status;
            csw.dCSWDataResidue = /*ntohl*/(Scsi_Residue);
            USB_In((BYTE*) &csw, sizeof(CSW));

            Msd_State = MSD_READY;
            break;

//      case MSD_DO_RESET:
                                                        // Fall-through
        default:
            Msd_State = MSD_READY;
            break;
    }
}

/* End of TimpyH_MSD_MSD.c */
